/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class BL extends Operation
{
    public static final String NAME = "BL";

    public static final IInfo INFO = new Info(BL.class, NAME);

    private final IAddressingMode cond;
    private final Location offset;

    public BL(IAddressingMode cond, Location offset)
    {
        assert Condition.INFO.isSupported(cond);
        assert Int24.equals(offset.getType());

        this.cond = cond;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("BL%s %x", cond.syntax(), offset.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%s1011%24b", cond.image(), offset.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            GPR.access(14).store(GPR.access(15).load());
            GPR.access(15).store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, GPR.access(15).load(), DataEngine.valueOf(word, 4)), DataEngine.coerce(new Type(ETypeID.CARD, 32), DataEngine.execute(EOperatorID.L_SHIFT, DataEngine.coerce(new Type(ETypeID.INT, 30), offset.load()), DataEngine.valueOf(new Type(ETypeID.INT, 30), 2)))));
            __CTRL_TRANSFER.set(1);
        }
    }
}
