/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class BLX2 extends Operation
{
    public static final String NAME = "BLX2";

    public static final IInfo INFO = new Info(BLX2.class, NAME);

    private final IAddressingMode cond;
    private final Location r;

    public BLX2(IAddressingMode cond, Location r)
    {
        assert Condition.INFO.isSupported(cond);
        assert index.equals(r.getType());

        this.cond = cond;
        this.r = r;
    }

    @Override
    public String syntax()
    {
        return String.format("BLX%s R%d", cond.syntax(), r.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%s000100100000000000000011%4b", cond.image(), r.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            target.access().store(GPR.access(DataEngine.intValue(r.load())).load());
            GPR.access(14).store(GPR.access(15).load());
            CPSR.access().bitField(5, 5).store(target.access().bitField(0, 0).load());
            GPR.access(15).store(DataEngine.execute(EOperatorID.BIT_AND, target.access().load(), DataEngine.valueOf(word, 0xfffffffe)));
            __CTRL_TRANSFER.set(1);
        }
    }
}
