/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class MOV extends Operation
{
    public static final String NAME = "MOV";

    public static final IInfo INFO = new Info(MOV.class, NAME);

    private final IAddressingMode cond;
    private final IAddressingMode sets;
    private final IAddressingMode src1;
    private final IAddressingMode src2;

    public MOV(IAddressingMode cond, IAddressingMode sets, IAddressingMode src1, IAddressingMode src2)
    {
        assert Condition.INFO.isSupported(cond);
        assert setS.INFO.isSupported(sets);
        assert REG.INFO.isSupported(src1);
        assert DATA_PROCESSING.INFO.isSupported(src2);

        this.cond = cond;
        this.sets = sets;
        this.src1 = src1;
        this.src2 = src2;
    }

    @Override
    public String syntax()
    {
        return String.format("MOV%s%s %s, %s", cond.syntax(), sets.syntax(), src1.syntax(), src2.syntax());
    }

    @Override
    public String image()
    {
        return String.format("%s0001101%s0000%s%s", cond.image(), sets.image(), src1.image(), src2.image());
    }

    @Override
    public void action()
    {
        cond.action();
        src2.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            ALU_OUT.access().store(src2.access().load());
            if (DataEngine.intValue(sets.access().load()) == 1 && DataEngine.intValue(src1.access().load()) == 15)
            {
                CPSR.access().store(SPSR.access().load());
            }
            else
            {
                if (DataEngine.intValue(sets.access().load()) == 1)
                {
                    CPSR.access().bitField(31, 31).store(ALU_OUT.access().bitField(31, 31).load());
                    if (DataEngine.intValue(ALU_OUT.access().load()) == 0)
                    {
                        CPSR.access().bitField(30, 30).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0x1));
                    }
                    else
                    {
                        CPSR.access().bitField(30, 30).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0x0));
                    }
                    CPSR.access().bitField(29, 29).store(shifter_carry_out.access().load());
                }
            }
            GPR.access(DataEngine.intValue(src1.access().load())).store(ALU_OUT.access().load());
        }
    }
}
