/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class MRS extends Operation
{
    public static final String NAME = "MRS";

    public static final IInfo INFO = new Info(MRS.class, NAME);

    private final IAddressingMode cond;
    private final IAddressingMode src1;
    private final Location src2;

    public MRS(IAddressingMode cond, IAddressingMode src1, Location src2)
    {
        assert Condition.INFO.isSupported(cond);
        assert FLAGREG.INFO.isSupported(src1);
        assert index.equals(src2.getType());

        this.cond = cond;
        this.src1 = src1;
        this.src2 = src2;
    }

    @Override
    public String syntax()
    {
        return String.format("MRS%s R%d,%s", cond.syntax(), src2.load().getRawData().intValue(), src1.syntax());
    }

    @Override
    public String image()
    {
        return String.format("%s00010%s000000%4b000000000000", cond.image(), src1.image(), src2.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(src1.access().load()) == 1)
        {
            GPR.access(DataEngine.intValue(src2.load())).store(SPSR.access().load());
        }
        else
        {
            GPR.access(DataEngine.intValue(src2.load())).store(CPSR.access().load());
        }
    }
}
