/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class STR_IMMEDIATE_OFF extends Operation
{
    public static final String NAME = "STR_IMMEDIATE_OFF";

    public static final IInfo INFO = new Info(STR_IMMEDIATE_OFF.class, NAME);

    private final IAddressingMode cond;
    private final IAddressingMode src1;
    private final Location r;
    private final IAddressingMode Ubit;
    private final Location offset;

    public STR_IMMEDIATE_OFF(IAddressingMode cond, IAddressingMode src1, Location r, IAddressingMode Ubit, Location offset)
    {
        assert Condition.INFO.isSupported(cond);
        assert REG.INFO.isSupported(src1);
        assert index.equals(r.getType());
        assert setU.INFO.isSupported(Ubit);
        assert new Type(ETypeID.CARD, 12).equals(offset.getType());

        this.cond = cond;
        this.src1 = src1;
        this.r = r;
        this.Ubit = Ubit;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("STR%s %s, [ R%d, #%s%d ]", cond.syntax(), src1.syntax(), r.load().getRawData().intValue(), Ubit.syntax(), offset.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%s0101%s000%4b%s%12b", cond.image(), Ubit.image(), r.load().getRawData().toBinString(), src1.image(), offset.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(r.load()) == 15)
        {
            if (DataEngine.intValue(Ubit.access().load()) == 1)
            {
                amode.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, GPR.access(DataEngine.intValue(r.load())).load(), DataEngine.valueOf(word, 4)), DataEngine.coerce(new Type(ETypeID.CARD, 32), offset.load())));
            }
            else
            {
                amode.access().store(DataEngine.execute(EOperatorID.MINUS, DataEngine.execute(EOperatorID.PLUS, GPR.access(DataEngine.intValue(r.load())).load(), DataEngine.valueOf(word, 4)), DataEngine.coerce(new Type(ETypeID.CARD, 32), offset.load())));
            }
        }
        else
        {
            if (DataEngine.intValue(Ubit.access().load()) == 1)
            {
                amode.access().store(DataEngine.execute(EOperatorID.PLUS, GPR.access(DataEngine.intValue(r.load())).load(), DataEngine.coerce(new Type(ETypeID.CARD, 32), offset.load())));
            }
            else
            {
                amode.access().store(DataEngine.execute(EOperatorID.MINUS, GPR.access(DataEngine.intValue(r.load())).load(), DataEngine.coerce(new Type(ETypeID.CARD, 32), offset.load())));
            }
        }
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            Location.concat(M.access(DataEngine.intValue(amode.access().load())), M.access(DataEngine.intValue(amode.access().load()) + 1), M.access(DataEngine.intValue(amode.access().load()) + 2), M.access(DataEngine.intValue(amode.access().load()) + 3)).store(GPR.access(DataEngine.intValue(src1.access().load())).load());
        }
    }
}
