/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class SWPB extends Operation
{
    public static final String NAME = "SWPB";

    public static final IInfo INFO = new Info(SWPB.class, NAME);

    private final IAddressingMode cond;
    private final IAddressingMode rn;
    private final IAddressingMode rd;
    private final IAddressingMode rm;

    public SWPB(IAddressingMode cond, IAddressingMode rn, IAddressingMode rd, IAddressingMode rm)
    {
        assert Condition.INFO.isSupported(cond);
        assert REG.INFO.isSupported(rn);
        assert REG.INFO.isSupported(rd);
        assert REG.INFO.isSupported(rm);

        this.cond = cond;
        this.rn = rn;
        this.rd = rd;
        this.rm = rm;
    }

    @Override
    public String syntax()
    {
        return String.format("SWP%sB %s,%s,%s", cond.syntax(), rd.syntax(), rm.syntax(), rn.syntax());
    }

    @Override
    public String image()
    {
        return String.format("%s00010100%s%s00001001%s", cond.image(), rn.image(), rd.image(), rm.image());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            amode.access().store(GPR.access(DataEngine.intValue(rn.access().load())).load());
            temp.access().bitField(7, 0).store(M.access(DataEngine.intValue(amode.access().load())).load());
            temp.access().bitField(15, 8).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0));
            temp.access().bitField(23, 16).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0));
            temp.access().bitField(31, 24).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0));
            M.access(DataEngine.intValue(amode.access().load())).store(GPR.access(DataEngine.intValue(rm.access().load())).bitField(7, 0).load());
            rd.access().store(temp.access().load());
        }
    }
}
