/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.shared;

import ru.ispras.microtesk.model.api.type.ETypeID;
import ru.ispras.microtesk.model.api.type.Type;
import ru.ispras.microtesk.model.api.memory.EMemoryKind;
import ru.ispras.microtesk.model.api.memory.Memory;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.state.Status;
import ru.ispras.microtesk.model.api.state.Resetter;

public final class Shared
{
    private Shared() {}

    public static final String byte_order = "little";
    public static final String PC = "GPR[15]";
    public static final String SP = "GPR[13]";
    public static final String FP = "GPR[12]";
    public static final String IP = "GPR[11]";

    public static final Type index = new Type(ETypeID.CARD, 4);
    public static final Type dword = new Type(ETypeID.CARD, 64);
    public static final Type word = new Type(ETypeID.CARD, 32);
    public static final Type hword = new Type(ETypeID.CARD, 16);
    public static final Type byte_t = new Type(ETypeID.CARD, 8);
    public static final Type nibble = new Type(ETypeID.CARD, 4);
    public static final Type bit = new Type(ETypeID.CARD, 1);
    public static final Type Bit5 = new Type(ETypeID.CARD, 5);
    public static final Type Bit12 = new Type(ETypeID.CARD, 12);
    public static final Type Int24 = new Type(ETypeID.INT, 24);

    public static final Memory GPR = new Memory(EMemoryKind.REG, "GPR", word, 32);
    public static final Memory FPS = new Memory(EMemoryKind.REG, "FPS", word, 1);
    public static final Memory CPSR = new Memory(EMemoryKind.REG, "CPSR", word, 1);
    public static final Memory SPSR = new Memory(EMemoryKind.REG, "SPSR", word, 1);
    public static final Memory CP15 = new Memory(EMemoryKind.REG, "CP15", word, 16);
    public static final Memory M = new Memory(EMemoryKind.MEM, "M", byte_t, (int)Math.pow(2, 10));
    public static final Memory amode = new Memory(EMemoryKind.VAR, "amode", word, 1);
    public static final Memory temp1 = new Memory(EMemoryKind.VAR, "temp1", word, 1);
    public static final Memory temp = new Memory(EMemoryKind.VAR, "temp", word, 1);
    public static final Memory shifter_carry_out = new Memory(EMemoryKind.VAR, "shifter_carry_out", bit, 1);
    public static final Memory ALU_OUT = new Memory(EMemoryKind.VAR, "ALU_OUT", word, 1);
    public static final Memory carry = new Memory(EMemoryKind.VAR, "carry", bit, 1);
    public static final Memory X = new Memory(EMemoryKind.VAR, "X", bit, 1);
    public static final Memory start_address = new Memory(EMemoryKind.VAR, "start_address", word, 1);
    public static final Memory end_address = new Memory(EMemoryKind.VAR, "end_address", word, 1);
    public static final Memory register_list = new Memory(EMemoryKind.VAR, "register_list", hword, 1);
    public static final Memory address = new Memory(EMemoryKind.VAR, "address", word, 1);
    public static final Memory target = new Memory(EMemoryKind.VAR, "target", word, 1);
    public static final Memory tempint64 = new Memory(EMemoryKind.VAR, "tempint64", new Type(ETypeID.INT, 64), 1);
    public static final Memory tempcard64 = new Memory(EMemoryKind.VAR, "tempcard64", new Type(ETypeID.CARD, 64), 1);
    public static final Memory operand1 = new Memory(EMemoryKind.VAR, "operand1", new Type(ETypeID.INT, 16), 1);
    public static final Memory operand2 = new Memory(EMemoryKind.VAR, "operand2", new Type(ETypeID.INT, 16), 1);
    public static final Memory Result48 = new Memory(EMemoryKind.VAR, "Result48", new Type(ETypeID.INT, 48), 1);
    public static final Memory op1 = new Memory(EMemoryKind.VAR, "op1", new Type(ETypeID.INT, 32), 1);
    public static final Memory op2 = new Memory(EMemoryKind.VAR, "op2", new Type(ETypeID.INT, 32), 1);
    public static final Memory sum = new Memory(EMemoryKind.VAR, "sum", new Type(ETypeID.INT, 64), 1);
    public static final Memory cmp_tmp = new Memory(EMemoryKind.VAR, "cmp_tmp", new Type(ETypeID.CARD, 32), 1);
    public static final Memory a = new Memory(EMemoryKind.VAR, "a", new Type(ETypeID.CARD, 32), 1);
    public static final Memory sd = new Memory(EMemoryKind.VAR, "sd", new Type(ETypeID.CARD, 5), 1);
    public static final Memory sn = new Memory(EMemoryKind.VAR, "sn", new Type(ETypeID.CARD, 5), 1);
    public static final Memory sm = new Memory(EMemoryKind.VAR, "sm", new Type(ETypeID.CARD, 5), 1);

    public static final Memory[] __REGISTERS = {GPR, FPS, CPSR, SPSR, CP15};
    public static final Memory[] __MEMORY = {M};
    public static final Memory[] __VARIABLES = {amode, temp1, temp, shifter_carry_out, ALU_OUT, carry, X, start_address, end_address, register_list, address, target, tempint64, tempcard64, operand1, operand2, Result48, op1, op2, sum, cmp_tmp, a, sd, sn, sm};
    public static final Label[] __LABELS = {new Label("PC", GPR, 15), new Label("SP", GPR, 13), new Label("FP", GPR, 12), new Label("IP", GPR, 11)};

    public static final Status __CTRL_TRANSFER = new Status("__CTRL_TRANSFER", 0);
    public static final Status[] __STATUSES = {__CTRL_TRANSFER};

    public static final Resetter __RESETTER = new Resetter(__VARIABLES, __STATUSES);
}
 