/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.instruction;

import ru.ispras.microtesk.model.api.situation.builtin.RandomSituation;
import ru.ispras.microtesk.model.api.situation.builtin.ZeroSituation;
import ru.ispras.microtesk.model.api.exception.ConfigurationException;
import ru.ispras.microtesk.model.api.instruction.IInstructionCall;
import ru.ispras.microtesk.model.api.instruction.IInstructionCallBuilderEx;
import ru.ispras.microtesk.model.api.simnml.instruction.InstructionCall;
import ru.ispras.microtesk.model.api.simnml.instruction.InstructionBase;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.situation.ISituation;
import ru.ispras.microtesk.model.mips.mode.*;
import ru.ispras.microtesk.model.mips.op.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class InstructionJR extends InstructionBase
{
    public static final String NAME = "JR";

    public static final ParamDecl[] PARAMS = new ParamDecl[] 
    {
       new ParamDecl("rs", REG_IND_ZERO.INFO)
    };

    public static final ISituation.IInfo[] SITUATIONS = new ISituation.IInfo[]
    {
        RandomSituation.INFO,
        ZeroSituation.INFO
    };

    public InstructionJR()
    {
        super(NAME, PARAMS, SITUATIONS);
    }

    @Override
    public IInstructionCallBuilderEx createCallBuilder()
    {
        return new Builder(); 
    }

    private class Builder extends CallBuilderBase
    {
        public Builder()
        {
            super(PARAMS);
        }

        @Override
        public IInstructionCall getCall() throws ConfigurationException
        {
            final IAddressingMode rs = getArgument("rs");

            return new InstructionCall(
                __RESETTER,
                new instruction(
                    new JR(
                        rs
                    )
                )
            );
        }
    }
     
}
 