/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.instruction;

import ru.ispras.microtesk.model.api.situation.builtin.RandomSituation;
import ru.ispras.microtesk.model.api.situation.builtin.ZeroSituation;
import ru.ispras.microtesk.model.api.exception.ConfigurationException;
import ru.ispras.microtesk.model.api.instruction.IInstructionCall;
import ru.ispras.microtesk.model.api.instruction.IInstructionCallBuilderEx;
import ru.ispras.microtesk.model.api.simnml.instruction.InstructionCall;
import ru.ispras.microtesk.model.api.simnml.instruction.InstructionBase;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.situation.ISituation;
import ru.ispras.microtesk.model.mips.mode.*;
import ru.ispras.microtesk.model.mips.op.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class InstructionLWR extends InstructionBase
{
    public static final String NAME = "LWR";

    public static final ParamDecl[] PARAMS = new ParamDecl[] 
    {
       new ParamDecl("base", REG_IND_ZERO.INFO),
       new ParamDecl("rt", REG_IND.INFO),
       new ParamDecl("offset", IMM16.INFO)
    };

    public static final ISituation.IInfo[] SITUATIONS = new ISituation.IInfo[]
    {
        RandomSituation.INFO,
        ZeroSituation.INFO
    };

    public InstructionLWR()
    {
        super(NAME, PARAMS, SITUATIONS);
    }

    @Override
    public IInstructionCallBuilderEx createCallBuilder()
    {
        return new Builder(); 
    }

    private class Builder extends CallBuilderBase
    {
        public Builder()
        {
            super(PARAMS);
        }

        @Override
        public IInstructionCall getCall() throws ConfigurationException
        {
            final IAddressingMode base = getArgument("base");
            final IAddressingMode rt = getArgument("rt");
            final IAddressingMode offset = getArgument("offset");

            return new InstructionCall(
                __RESETTER,
                new instruction(
                    new LWR(
                        base,
                        rt,
                        offset
                    )
                )
            );
        }
    }
     
}
 