/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class JAL extends Operation
{
    public static final String NAME = "JAL";

    public static final IInfo INFO = new Info(JAL.class, NAME);

    private final IAddressingMode target;

    public JAL(IAddressingMode target)
    {
        assert IMM26.INFO.isSupported(target);

        this.target = target;
    }

    @Override
    public String syntax()
    {
        return String.format("JAL %s", target.syntax());
    }

    @Override
    public String image()
    {
        return String.format("000011%s", target.image());
    }

    @Override
    public void action()
    {
        branch.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
        CIA.access().store(NIA.access().load());
        JMPADDR.access().store(DataEngine.execute(EOperatorID.BIT_AND, CIA.access().load(), DataEngine.valueOf(long_t, -268435456)));
        JMPADDR.access().store(DataEngine.execute(EOperatorID.BIT_OR, DataEngine.coerce(new Type(ETypeID.INT, 32), JMPADDR.access().load()), DataEngine.coerce(new Type(ETypeID.INT, 32), DataEngine.execute(EOperatorID.L_SHIFT, target.access().load(), DataEngine.valueOf(new Type(ETypeID.INT, 26), 2)))));
        GPR.access(31).store(DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(long_t, 4)));
    }
}
