/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class LUI extends Operation
{
    public static final String NAME = "LUI";

    public static final IInfo INFO = new Info(LUI.class, NAME);

    private final IAddressingMode rt;
    private final IAddressingMode offset;

    public LUI(IAddressingMode rt, IAddressingMode offset)
    {
        assert REG_IND.INFO.isSupported(rt);
        assert IMM16.INFO.isSupported(offset);

        this.rt = rt;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("LUI %s, %s", rt.syntax(), offset.syntax());
    }

    @Override
    public String image()
    {
        return String.format("00111100000%s%s", rt.image(), offset.image());
    }

    @Override
    public void action()
    {
        GPR.access(DataEngine.intValue(rt.access().load())).store(DataEngine.execute(EOperatorID.L_SHIFT, offset.access().load(), DataEngine.valueOf(new Type(ETypeID.INT, 16), 16)));
    }
}
