/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class MULTU extends Operation
{
    public static final String NAME = "MULTU";

    public static final IInfo INFO = new Info(MULTU.class, NAME);

    private final IAddressingMode rs;
    private final IAddressingMode rt;

    public MULTU(IAddressingMode rs, IAddressingMode rt)
    {
        assert REG_IND_ZERO.INFO.isSupported(rs);
        assert REG_IND_ZERO.INFO.isSupported(rt);

        this.rs = rs;
        this.rt = rt;
    }

    @Override
    public String syntax()
    {
        return String.format("MULTU %s, %s", rs.syntax(), rt.syntax());
    }

    @Override
    public String image()
    {
        return String.format("000000%s%s0000000000011001", rs.image(), rt.image());
    }

    @Override
    public void action()
    {
        TMP_SDWORD.access().store(DataEngine.execute(EOperatorID.MUL, DataEngine.coerce(new Type(ETypeID.CARD, 32), rs.access().load()), DataEngine.coerce(new Type(ETypeID.CARD, 32), rt.access().load())));
        HI.access().bitField(31, 0).store(TMP_SDWORD.access().bitField(63, 32).load());
        LO.access().bitField(31, 0).store(TMP_SDWORD.access().bitField(31, 0).load());
    }

    public void sizecheck()
    {
        tmp_signed_word.access().store(rs.access().load());
        tmp_signed_word.access().store(DataEngine.execute(EOperatorID.BIT_AND, tmp_signed_word.access().load(), DataEngine.valueOf(new Type(ETypeID.INT, 32), 0xffff0000)));
        if (DataEngine.intValue(tmp_signed_word.access().load()) == 0x0)
        {
            multsize.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0));
        }
        else
        {
            multsize.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
        }
    }
}
