/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class SRA extends Operation
{
    public static final String NAME = "SRA";

    public static final IInfo INFO = new Info(SRA.class, NAME);

    private final Location rd;
    private final IAddressingMode rt;
    private final Location sa;

    public SRA(Location rd, IAddressingMode rt, Location sa)
    {
        assert index.equals(rd.getType());
        assert REG_IND_ZERO.INFO.isSupported(rt);
        assert index.equals(sa.getType());

        this.rd = rd;
        this.rt = rt;
        this.sa = sa;
    }

    @Override
    public String syntax()
    {
        return String.format("SRA %d, %s, %d", rd.load().getRawData().intValue(), rt.syntax(), sa.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("00000000000%s%5b%5b000011", rt.image(), rd.load().getRawData().toBinString(), sa.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.execute(EOperatorID.R_SHIFT, rt.access().load(), DataEngine.coerce(signed_long, sa.load())));
        if (DataEngine.intValue(rt.access().load()) < 0)
        {
            GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.execute(EOperatorID.BIT_OR, GPR.access(DataEngine.intValue(rd.load())).load(), DataEngine.coerce(signed_long, DataEngine.execute(EOperatorID.MINUS, DataEngine.valueOf(index, 0), DataEngine.execute(EOperatorID.L_SHIFT, DataEngine.valueOf(index, 1), DataEngine.execute(EOperatorID.MINUS, DataEngine.valueOf(index, 32), sa.load()))))));
        }
    }
}
