/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class SWR extends Operation
{
    public static final String NAME = "SWR";

    public static final IInfo INFO = new Info(SWR.class, NAME);

    private final IAddressingMode base;
    private final IAddressingMode rt;
    private final IAddressingMode offset;

    public SWR(IAddressingMode base, IAddressingMode rt, IAddressingMode offset)
    {
        assert REG_IND_ZERO.INFO.isSupported(base);
        assert REG_IND.INFO.isSupported(rt);
        assert IMM16.INFO.isSupported(offset);

        this.base = base;
        this.rt = rt;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("SWR %s, %s(%s)", rt.syntax(), offset.syntax(), base.syntax());
    }

    @Override
    public String image()
    {
        return String.format("101110%s%s%s", base.image(), rt.image(), offset.image());
    }

    @Override
    public void action()
    {
        EA.access().store(DataEngine.execute(EOperatorID.PLUS, base.access().load(), DataEngine.coerce(signed_long, offset.access().load())));
        tmp_signed_word.access().store(GPR.access(DataEngine.intValue(rt.access().load())).load());
        if (DataEngine.intValue(EA.access().bitField(1, 0).load()) == 0)
        {
            M.access(DataEngine.intValue(EA.access().load())).store(tmp_signed_word_A3.access().load());
        }
        else
        {
            if (DataEngine.intValue(EA.access().bitField(1, 0).load()) == 1)
            {
                M.access(DataEngine.intValue(EA.access().load())).store(tmp_signed_word_A3.access().load());
                M.access(DataEngine.intValue(EA.access().load()) - 1).store(tmp_signed_word_A2.access().load());
            }
            else
            {
                if (DataEngine.intValue(EA.access().bitField(1, 0).load()) == 2)
                {
                    M.access(DataEngine.intValue(EA.access().load())).store(tmp_signed_word_A3.access().load());
                    M.access(DataEngine.intValue(EA.access().load()) - 1).store(tmp_signed_word_A2.access().load());
                    M.access(DataEngine.intValue(EA.access().load()) - 2).store(tmp_signed_word_A1.access().load());
                }
                else
                {
                    M.access(DataEngine.intValue(EA.access().load())).store(tmp_signed_word_A3.access().load());
                    M.access(DataEngine.intValue(EA.access().load()) - 1).store(tmp_signed_word_A2.access().load());
                    M.access(DataEngine.intValue(EA.access().load()) - 2).store(tmp_signed_word_A1.access().load());
                    M.access(DataEngine.intValue(EA.access().load()) - 3).store(tmp_signed_word_A0.access().load());
                }
            }
        }
    }
}
